Index: issm/trunk/src/modules/Chaco/Chaco.cpp
===================================================================
--- issm/trunk/src/modules/Chaco/Chaco.cpp	(revision 12709)
+++ issm/trunk/src/modules/Chaco/Chaco.cpp	(revision 13395)
@@ -9,8 +9,12 @@
 #endif
 
-
 #include "./Chaco.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void ChacoUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("Usage: [assgn] = Chaco(A,vwgts,ewgts,x,y,z,options,nparts,goal);");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Chaco){
    
 	int i;
@@ -42,5 +46,5 @@
 
 	#ifndef _HAVE_CHACO_ //only works if dakota library has been compiled in.
-	_error2_("Chaco not available! Cannot carry out Chaco partitioning!");
+	_error_("Chaco not available! Cannot carry out Chaco partitioning!");
 	#endif
 
@@ -54,14 +58,14 @@
 	nvtxs = mxGetN(A_IN);
 	mwstart = mxGetJc(A_IN);
-	start=(int*)xmalloc((nvtxs+1)*sizeof(int));
+	start=xNew<int>((nvtxs+1));
 	for (i=0; i<nvtxs+1;i++)start[i]=(int)mwstart[i];
 
 	mwadjacency = mxGetIr(A_IN);
-	adjacency = (int*)xmalloc(mxGetNzmax(A_IN)*sizeof(int));
+	adjacency = xNew<int>(mxGetNzmax(A_IN));
 	for (i=0; i<mxGetNzmax(A_IN); i++) adjacency[i]= (int)mwadjacency[i];
 
 	nedges = start[nvtxs];
 	if(!mxIsEmpty(EWGTS_IN)){
-		ewgts = (float*)xcalloc(nedges, sizeof(float));
+		ewgts = xNewZeroInit<float>(nedges);
 		doublepointer=mxGetPr(A_IN);
 		for (i = 0; i < nedges; i++)ewgts[i] = (float)doublepointer[i];
@@ -77,5 +81,5 @@
 	for (i=0;i<(nterms<10?nterms:10);i++) options[i]=in_options[i]; //copy in_options into default options
 	FetchData(&npart,NPARTS_IN); 
-	nparts=(int*)xmalloc(sizeof(int)); nparts[0]=npart; //weird Chacox interface ain't it?
+	nparts=xNew<int>(1); nparts[0]=npart; //weird Chacox interface ain't it?
 	FetchData(&goal,&nterms,GOAL_IN); 
 	
@@ -104,5 +108,5 @@
 	
 	/*Allocate output: */
-	assignment = (short*)xcalloc(nvtxs, sizeof(short));
+	assignment = xNewZeroInit<short>(nvtxs);
 	
     /*Call core: */
@@ -110,28 +114,22 @@
 
     /*Output data: */
-	doubleassignment=(double*)xmalloc(nvtxs*sizeof(double));
+	doubleassignment=xNew<double>(nvtxs);
 	for(i=0;i<nvtxs;i++) doubleassignment[i]=(double)assignment[i];
 	WriteData(ASSGN_OUT,doubleassignment,nvtxs);
 
 	/*Free ressources:*/
-	xfree((void**)&assignment); 
-	xfree((void**)&goal);
-	xfree((void**)&nparts);
-	xfree((void**)&z);
-	xfree((void**)&y);
-	xfree((void**)&x);
-	xfree((void**)&ewgts);
-	xfree((void**)&vwgts);
-	xfree((void**)&adjacency);
-	xfree((void**)&start);
-	xfree((void**)&doubleassignment);
+	xDelete<short>(assignment); 
+	xDelete<double>(goal);
+	xDelete<int>(nparts);
+	xDelete<float>(z);
+	xDelete<float>(y);
+	xDelete<float>(x);
+	xDelete<float>(ewgts);
+	xDelete<int>(vwgts);
+	xDelete<int>(adjacency);
+	xDelete<int>(start);
+	xDelete<double>(doubleassignment);
 
 	/*end module: */
 	MODULEEND();
 }
-
-void ChacoUsage(void){
-	_pprintLine_("");
-	_pprintLine_("Usage: [assgn] = Chaco(A,vwgts,ewgts,x,y,z,options,nparts,goal);");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/Chaco/Chaco.h
===================================================================
--- issm/trunk/src/modules/Chaco/Chaco.h	(revision 12709)
+++ issm/trunk/src/modules/Chaco/Chaco.h	(revision 13395)
@@ -6,11 +6,19 @@
 #define _CHACO_H
 
-/* local prototypes: */
-void ChacoUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
 
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+/*headers*/
 #include <stdio.h>
 #include <string.h>    /*  strcasecmp  */
 #include <time.h>      /*  clock,time,difftime  */
-
 #include "../../c/include/globals.h"
 #include "../../c/modules/modules.h"
@@ -18,18 +26,37 @@
 #include "../../c/shared/shared.h"
 #include "../../c/issm-binding.h"
-    
+
+#undef __FUNCT__ 
+#define __FUNCT__  "Chaco"
+
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define A_IN (mxArray*)prhs[0]
-#define VWGTS_IN (mxArray*)prhs[1]
-#define EWGTS_IN (mxArray*)prhs[2]
-#define X_IN (mxArray*)prhs[3]
-#define Y_IN (mxArray*)prhs[4]
-#define Z_IN (mxArray*)prhs[5]
-#define OPTNS_IN (mxArray*)prhs[6]
-#define NPARTS_IN (mxArray*)prhs[7]
-#define GOAL_IN (mxArray*)prhs[8]
-
+#define A_IN      prhs[0]
+#define VWGTS_IN  prhs[1]
+#define EWGTS_IN  prhs[2]
+#define X_IN      prhs[3]
+#define Y_IN      prhs[4]
+#define Z_IN      prhs[5]
+#define OPTNS_IN  prhs[6]
+#define NPARTS_IN prhs[7]
+#define GOAL_IN   prhs[8]
 /* serial output macros: */
 #define ASSGN_OUT (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define A_IN      PyTuple_GetItem(args,0)
+#define VWGTS_IN  PyTuple_GetItem(args,1)
+#define EWGTS_IN  PyTuple_GetItem(args,2)
+#define X_IN      PyTuple_GetItem(args,3)
+#define Y_IN      PyTuple_GetItem(args,4)
+#define Z_IN      PyTuple_GetItem(args,5)
+#define OPTNS_IN  PyTuple_GetItem(args,6)
+#define NPARTS_IN PyTuple_GetItem(args,7)
+#define GOAL_IN   PyTuple_GetItem(args,8)
+/* serial output macros: */
+#define ASSGN_OUT output,0
+#endif
 
 /* serial arg counts: */
@@ -39,6 +66,3 @@
 #define NRHS  9
 
-#undef __FUNCT__ 
-#define __FUNCT__  "Chaco"
-
 #endif  /* _CHACO_H */
Index: issm/trunk/src/modules/ContourToMesh/ContourToMesh.cpp
===================================================================
--- issm/trunk/src/modules/ContourToMesh/ContourToMesh.cpp	(revision 12709)
+++ issm/trunk/src/modules/ContourToMesh/ContourToMesh.cpp	(revision 13395)
@@ -2,93 +2,9 @@
     \brief: takes an  contour file, and figures out which nodes or elements from the mesh  
     are inside this contour. 
-	usage:
-	[in_nod,in_elem]=ContourToMesh(index,x,y,contours,interptype,edgevalue);
-	
-	input:
-
-		index,x,y: delaunay triangulation.
-		contours: structure holding sets of vertices making open contours. 
-		interptype: string definining type of interpolation ('element', or 'node', or 'element and node');
-		edgevalue: integer (0, 1 or 2) defining the value associated to the nodes on the edges of the polygons
-
-	output:
-		in_nod: vector of flags (0 or 1), of size nods if interptype is set to 'node' or 'element and node', 
-				or of size 0 otherwise.
-		in_elem: vector of flags (0 or 1), of size nel if interptype is set to 'element' or 'element and node', 
-				or of size 0 otherwise.
 */
 	
 #include "./ContourToMesh.h"
 
-WRAPPER(ContourToMesh){
-
-	int i,j;
-
-	/* required input: */
-	int     edgevalue;
-	double *index      = NULL;
-	int     nel;
-	double *x          = NULL;
-	int     nods;
-	double *y          = NULL;
-	char   *interptype = NULL;
-	char* contourname  = NULL;
-	DataSet* contours  = NULL;
-
-	/* output: */
-	Vector *in_nod  = NULL;
-	Vector *in_elem = NULL;
-
-	/*Boot module: */
-	MODULEBOOT();
-
-	/*checks on output arguments on the matlab side: */
-	#ifdef _HAVE_MATLAB_MODULES_
-	if(nlhs!=1 && nlhs!=2){
-		ContourToMeshUsage();
-		_error2_("usage. See above");
-	}
-	#endif
-	/*check on input arguments: */
-	if(nrhs!=NRHS){
-		ContourToMeshUsage();
-		_error2_("usage. See above");
-	}
-
-
-	/*Fetch inputs: */
-	FetchData(&index,&nel,NULL,INDEX);
-	FetchData(&x,&nods,NULL,X);
-	FetchData(&y,NULL,NULL,Y);
-	FetchData(&edgevalue,EDGEVALUE);
-	FetchData(&contourname,CONTOURNAME);
-	contours=DomainOutlineRead(contourname);
-
-	/*Fetch  interptype: */
-	FetchData(&interptype,INTERPTYPE);
-
-	/*Run interpolation routine: */
-	ContourToMeshx( &in_nod,&in_elem,index,x,y,contours,interptype,nel,nods,edgevalue);
-
-	/* output: */
-	if (strcmp(interptype,"node")==0){
-		WriteData(PLHS0,in_nod);
-	}
-	else if (strcmp(interptype,"element")==0){
-		WriteData(PLHS0,in_elem);
-	}
-	else if (strcmp(interptype,"element and node")==0){
-		WriteData(PLHS0,in_nod);
-		WriteData(PLHS1,in_elem);
-	}
-	else _error2_("wrong interpolation type");
-
-	/*end module: */
-	MODULEEND();
-	
-}
-
-void ContourToMeshUsage(void)//{{{1
-{
+void ContourToMeshUsage(void){/*{{{*/
 	_printLine_("CONTOURTOMESH - Flag the elements or nodes inside a contour");
 	_printLine_("");
@@ -110,4 +26,62 @@
 	_printLine_("         [in_nodes,in_elements]=ContourToMesh(md.elements,md.x,md.y,'Contour.exp','element and node',0)");
 	_printLine_("");
+}/*}}}*/
+WRAPPER(ContourToMesh){
+
+	/* required input: */
+	int      edgevalue;
+	double  *index       = NULL;
+	int      nel;
+	double  *x           = NULL;
+	int      nods;
+	double  *y           = NULL;
+	char    *interptype  = NULL;
+	DataSet *contours    = NULL;
+
+	/* output: */
+	SeqVec<double> *in_nod  = NULL;
+	SeqVec<double> *in_elem = NULL;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on output arguments on the matlab side: */
+	#ifdef _HAVE_MATLAB_MODULES_
+	if(nlhs!=1 && nlhs!=2){
+		ContourToMeshUsage();
+		_error_("usage. See above");
+	}
+	#endif
+	/*check on input arguments: */
+	if(nrhs!=NRHS){
+		ContourToMeshUsage();
+		_error_("usage. See above");
+	}
+
+	/*Fetch inputs: */
+	FetchData(&index,&nel,NULL,INDEX);
+	FetchData(&x,&nods,NULL,X);
+	FetchData(&y,NULL,NULL,Y);
+	FetchData(&edgevalue,EDGEVALUE);
+	FetchData(&contours,CONTOUR);
+	FetchData(&interptype,INTERPTYPE);
+
+	/*Run interpolation routine: */
+	ContourToMeshx( &in_nod,&in_elem,index,x,y,contours,interptype,nel,nods,edgevalue);
+
+	/* output: */
+	if (strcmp(interptype,"node")==0){
+		WriteData(PLHS0,in_nod);
+	}
+	else if (strcmp(interptype,"element")==0){
+		WriteData(PLHS0,in_elem);
+	}
+	else if (strcmp(interptype,"element and node")==0){
+		WriteData(PLHS0,in_nod);
+		WriteData(PLHS1,in_elem);
+	}
+	else _error_("wrong interpolation type");
+
+	/*end module: */
+	MODULEEND();
 }
-//}}}
Index: issm/trunk/src/modules/ContourToMesh/ContourToMesh.h
===================================================================
--- issm/trunk/src/modules/ContourToMesh/ContourToMesh.h	(revision 12709)
+++ issm/trunk/src/modules/ContourToMesh/ContourToMesh.h	(revision 13395)
@@ -1,19 +1,16 @@
-
 /*
 	ContourToMesh.h
 */
 
-
 #ifndef _CONTOURTOMESH_H
 #define _CONTOURTOMESH_H
-
 
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
 #else
-#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
 
-/*Very important definition in case we are compiling a python module!: needs to come before header files inclusion*/
+/*For python modules: needs to come before header files inclusion*/
 #ifdef _HAVE_PYTHON_
 #define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
@@ -31,12 +28,15 @@
 #include "../../c/EnumDefinitions/EnumDefinitions.h"
 
+#undef __FUNCT__
+#define __FUNCT__ "ContourToMesh"
+
 #ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define INDEX (mxArray *)prhs[0]
-#define X (mxArray *)prhs[1]
-#define Y (mxArray *)prhs[2]
-#define CONTOURNAME (mxArray *)prhs[3]
-#define INTERPTYPE (mxArray *)prhs[4]
-#define EDGEVALUE (mxArray *)prhs[5]
+#define INDEX       prhs[0]
+#define X           prhs[1]
+#define Y           prhs[2]
+#define CONTOUR     prhs[3]
+#define INTERPTYPE  prhs[4]
+#define EDGEVALUE   prhs[5]
 /* serial output macros: */
 #define PLHS0 (mxArray**)&plhs[0]
@@ -46,17 +46,14 @@
 #ifdef _HAVE_PYTHON_MODULES_
 /* serial input macros: */
-#define INDEX PyTuple_GetItem(args,0)
-#define X PyTuple_GetItem(args,1)
-#define Y PyTuple_GetItem(args,2)
-#define CONTOURNAME PyTuple_GetItem(args,3)
-#define INTERPTYPE PyTuple_GetItem(args,4)
-#define EDGEVALUE PyTuple_GetItem(args,5)
+#define INDEX       PyTuple_GetItem(args,0)
+#define X           PyTuple_GetItem(args,1)
+#define Y           PyTuple_GetItem(args,2)
+#define CONTOUR     PyTuple_GetItem(args,3)
+#define INTERPTYPE  PyTuple_GetItem(args,4)
+#define EDGEVALUE   PyTuple_GetItem(args,5)
 /* serial output macros: */
 #define PLHS0 output,0
 #define PLHS1 output,1
 #endif
-
-#undef __FUNCT__
-#define __FUNCT__ "ContourToMesh"
 
 /* serial arg counts: */
@@ -66,7 +63,4 @@
 #define NRHS 6
 
-/* local prototypes: */
-void ContourToMeshUsage(void);
-
 #endif  /* _CONTOURTOMESH_H */
 
Index: issm/trunk/src/modules/ContourToNodes/ContourToNodes.cpp
===================================================================
--- issm/trunk/src/modules/ContourToNodes/ContourToNodes.cpp	(revision 12709)
+++ issm/trunk/src/modules/ContourToNodes/ContourToNodes.cpp	(revision 13395)
@@ -1,46 +1,29 @@
 /*! \file  ContourtoNodes
     \brief: takes a  contour file, and figures out which nodes  (x,y list)
-    are inside this contour. 
-
-	usage:
-	[flags]=ContourToNodes(x,y,contours,interptype,edgevalue);
-	
-	where:
-
-	input:
-
-		x,y: node cooredinates
-		
-		contours: structure holding sets of vertices making open contours. 
-		
-		interptype: string definining type of interpolation ('element', or 'node', or 'element and node');
-
-		edgevalue: integer (0, 1 or 2) defining the value associated to the nodes on the edges of the polygons
-
-	output:
-		flags: vector of flags (0 or 1), of size nods 
 */
 	
 #include "./ContourToNodes.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]) {
+void ContourToNodesUsage(void){/*{{{*/
+	_printLine_("   usage:");
+	_printLine_("   [flags]=ContourToNodes(x,y,contourname,edgevalue);\n");
+	_printLine_("   where:");
+	_printLine_("      x,y: list of nodes.");
+	_printLine_("      contourname: name of .exp file containing the contours, or resulting structure from call to expread.");
+	_printLine_("      edgevalue: integer (0, 1 or 2) defining the value associated to the nodes on the edges of the polygons.");
+	_printLine_("      flags: vector of flags (0 or 1), of size nods.");
+	_printLine_("");
+}/*}}}*/
+WRAPPER(ContourToNodes){
 
-	int i,j;
-
-	/* required input: */
-	double* x=NULL;
-	double* y=NULL;
-	int     edgevalue;
-	char*   interptype=NULL;
+	/* input: */
+	int      edgevalue,nods;
+	double  *x           = NULL;
+	double  *y           = NULL;
+	char    *contourname = NULL;
+	DataSet *contours    = NULL;
 
 	/* output: */
-	Vector*  flags=NULL;
-	int  nods;
-
-	//contours
-	mxArray*  matlabstructure=NULL;
-	int numcontours;
-	Contour** contours=NULL;
-	Contour*  contouri=NULL;
+	SeqVec<double> *flags = NULL;
 
 	/*Boot module: */
@@ -48,49 +31,14 @@
 
 	/*checks on arguments on the matlab side: */
-	CheckNumMatlabArguments(nlhs,NLHS,nrhs,NRHS,__FUNCT__,&ContourToNodesUsage);
-
+	CHECKARGUMENTS(NLHS,NRHS,&ContourToNodesUsage);
 	
 	/*Fetch inputs: */
 	FetchData(&x,&nods,NULL,XHANDLE);
 	FetchData(&y,NULL,NULL,YHANDLE);
-	FetchData(&edgevalue,EDGEVALUEHANDLE);
+	FetchData(&edgevalue,EDGEVALUE);
+	FetchData(&contours,CONTOUR);
 
-	//Fetch contours
-
-	if(mxIsChar(FILENAME)){
-		/*Call expread on filename to build a contour array in the matlab workspace: */
-		mexCallMATLAB( 1, &matlabstructure, 1, (mxArray**)&FILENAME, "expread");
-	}
-	else{
-		/*FILENAME is actually a structure, coming directly from expread: */
-		matlabstructure=(mxArray*)FILENAME;
-	}
-
-	numcontours=mxGetNumberOfElements(matlabstructure);
-	contours=(Contour**)xmalloc(numcontours*sizeof(Contour*));
-	for(i=0;i<numcontours;i++){
-		//allocate
-		contouri=(Contour*)xmalloc(sizeof(Contour));
-		//retrieve dimension of this contour.
-		contouri->nods=(int)mxGetScalar(mxGetField(matlabstructure,i,"nods"));
-		//set pointers.
-		contouri->x=mxGetPr(mxGetField(matlabstructure,i,"x"));
-		contouri->y=mxGetPr(mxGetField(matlabstructure,i,"y"));
-		*(contours+i)=contouri;
-	}
-
-	/* Debugging of contours :{{{1*/
-	/*for(i=0;i<numcontours;i++){
-		_printLine_("\nContour echo: contour number  " << i+1 << " / " << numcontours);
-		contouri=*(contours+i);
-		_printLine_("   Number of nodes " << contouri->nods);
-		for (j=0;j<contouri->nods;j++){
-			_printLine_("   " << *(contouri->x+j) << "f " << *(contouri->y+j) << "f");
-		}
-	}*/
-	/*}}}*/
-
-	/*Run interpolation routine: */
-	ContourToNodesx(&flags,x,y,nods,contours,numcontours,edgevalue);
+	/*Run x layer */
+	ContourToNodesx(&flags,x,y,nods,contours,edgevalue);
 
 	/* output: */
@@ -99,16 +47,3 @@
 	/*end module: */
 	MODULEEND();
-
 }
-
-void ContourToNodesUsage(void){
-	_printLine_("   usage:");
-	_printLine_("   [flags]=ContourToNodes(x,y,contourname,edgevalue);\n");
-	_printLine_("   where:");
-	_printLine_("      x,y: list of nodes.");
-	_printLine_("      contourname: name of .exp file containing the contours, or resulting structure from call to expread.");
-	_printLine_("      interptype: string definining type of interpolation ('element', or 'node').");
-	_printLine_("      edgevalue: integer (0, 1 or 2) defining the value associated to the nodes on the edges of the polygons.");
-	_printLine_("      flags: vector of flags (0 or 1), of size nods.");
-	_printLine_("");
-}
Index: issm/trunk/src/modules/ContourToNodes/ContourToNodes.h
===================================================================
--- issm/trunk/src/modules/ContourToNodes/ContourToNodes.h	(revision 12709)
+++ issm/trunk/src/modules/ContourToNodes/ContourToNodes.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	ContourToNodes.h
 */
 
-
 #ifndef _CONTOURTONODES_H
 #define _CONTOURTONODES_H
 
-/* local prototypes: */
-void ContourToNodesUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -20,17 +26,25 @@
 #define __FUNCT__ "ContourToNodes"
 
-
-#ifndef ALL
-#define ALL 0
-#endif
-
+#ifdef _HAVE_MATLAB_MODULES_
 /* input macros: */
-#define XHANDLE prhs[0]
-#define YHANDLE prhs[1]
-#define FILENAME prhs[2]
-#define EDGEVALUEHANDLE prhs[3]
+#define XHANDLE   prhs[0]
+#define YHANDLE   prhs[1]
+#define CONTOUR   prhs[2]
+#define EDGEVALUE prhs[3]
 
 /* serial output macros: */
 #define FLAGS (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* input macros: */
+#define XHANDLE   PyTuple_GetItem(args,0)
+#define YHANDLE   PyTuple_GetItem(args,1)
+#define CONTOUR   PyTuple_GetItem(args,2)
+#define EDGEVALUE PyTuple_GetItem(args,3)
+
+/* serial output macros: */
+#define FLAGS output,0
+#endif
 
 /* serial arg counts: */
@@ -40,5 +54,4 @@
 #define NRHS 4
 
-
 #endif  /* _CONTOURTONODES_H */
 
Index: issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.cpp
===================================================================
--- issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.cpp	(revision 12709)
+++ issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.cpp	(revision 13395)
@@ -5,4 +5,9 @@
 #include "./ElementConnectivity.h"
 
+void ElementConnectivityUsage(void) {/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: elementconnectivity = " << __FUNCT__ << "(elements, nodeconnectivity);");
+	_pprintLine_("");
+}/*}}}*/
 WRAPPER(ElementConnectivity){
 
@@ -35,8 +40,2 @@
 	MODULEEND();
 }
-
-void ElementConnectivityUsage(void) {
-	_pprintLine_("");
-	_pprintLine_("   usage: elementconnectivity = " << __FUNCT__ << "(elements, nodeconnectivity);");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.h
===================================================================
--- issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.h	(revision 12709)
+++ issm/trunk/src/modules/ElementConnectivity/ElementConnectivity.h	(revision 13395)
@@ -9,8 +9,8 @@
 	#include <config.h>
 #else
-#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
 
-/*Very important definition in case we are compiling a python module!: needs to come before header files inclusion*/
+/*For python modules: needs to come before header files inclusion*/
 #ifdef _HAVE_PYTHON_
 #define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
@@ -28,9 +28,11 @@
 #include "../../c/EnumDefinitions/EnumDefinitions.h"
 
+#undef __FUNCT__ 
+#define __FUNCT__  "ElementConnectivity"
+
 #ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-/* serial input macros: */
-#define ELEMENTS (mxArray*)prhs[0]
-#define NODECONNECTIVITY (mxArray*)prhs[1]
+#define ELEMENTS         prhs[0]
+#define NODECONNECTIVITY prhs[1]
 /* serial output macros: */
 #define ELEMENTCONNECTIVITY (mxArray**)&plhs[0]
@@ -39,13 +41,9 @@
 #ifdef _HAVE_PYTHON_MODULES_
 /* serial input macros: */
-/* serial input macros: */
-#define ELEMENTS PyTuple_GetItem(args,0)
+#define ELEMENTS         PyTuple_GetItem(args,0)
 #define NODECONNECTIVITY PyTuple_GetItem(args,1)
 /* serial output macros: */
 #define ELEMENTCONNECTIVITY output,0
 #endif
-
-#undef __FUNCT__ 
-#define __FUNCT__  "ElementConnectivity"
 
 /* serial arg counts: */
@@ -55,6 +53,3 @@
 #define NRHS  2
 
-/* local prototypes: */
-void ElementConnectivityUsage(void);
-
 #endif  /* _ELEMENTCONNECTIVITY_H */
Index: issm/trunk/src/modules/EnumToString/EnumToString.cpp
===================================================================
--- issm/trunk/src/modules/EnumToString/EnumToString.cpp	(revision 12709)
+++ issm/trunk/src/modules/EnumToString/EnumToString.cpp	(revision 13395)
@@ -5,13 +5,19 @@
 #include "./EnumToString.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void EnumToStringUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: " << __FUNCT__ << "string = EnumToString(enum);");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(EnumToString){
 
 	char    *name    = NULL;
 	int      enum_in;
 
-	/*checks on arguments on the matlab side: */
-	if(nrhs!=NRHS){
-		EnumToStringUsage(); _error2_("usage. See above");
-	}
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments: */
+	CHECKARGUMENTS(NLHS,NRHS,&EnumToStringUsage);
 
 	/*Fetch inputs: */
@@ -23,10 +29,6 @@
 	/* output: */
 	WriteData(NAME,name);
+
+	/*end module: */
+	MODULEEND();
 }
-
-void EnumToStringUsage(void)
-{
-	_pprintLine_("");
-	_pprintLine_("   usage: " << __FUNCT__ << "string = EnumToString(enum);");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/EnumToString/EnumToString.h
===================================================================
--- issm/trunk/src/modules/EnumToString/EnumToString.h	(revision 12709)
+++ issm/trunk/src/modules/EnumToString/EnumToString.h	(revision 13395)
@@ -6,7 +6,16 @@
 #define _ENUMTOSTRING_H
 
-/* local prototypes: */
-void EnumToStringUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
 
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
+
+/*Header files: */
 #include "../../c/include/globals.h"
 #include "../../c/modules/modules.h"
@@ -14,10 +23,21 @@
 #include "../../c/shared/shared.h"
 #include "../../c/issm-binding.h"
-    
+
+#undef __FUNCT__ 
+#define __FUNCT__  "EnumToString"
+ 
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
 #define ENUMIN (mxArray*)prhs[0]
-
 /* serial output macros: */
 #define NAME (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define ENUMIN PyTuple_GetItem(args,0)
+/* serial output macros: */
+#define NAME output,0
+#endif
 
 /* serial arg counts: */
@@ -27,6 +47,3 @@
 #define NRHS  1
 
-#undef __FUNCT__ 
-#define __FUNCT__  "EnumToString"
-
 #endif  /* _TEST_H */
Index: issm/trunk/src/modules/Exp2Kml/Exp2Kml.cpp
===================================================================
--- issm/trunk/src/modules/Exp2Kml/Exp2Kml.cpp	(revision 12709)
+++ issm/trunk/src/modules/Exp2Kml/Exp2Kml.cpp	(revision 13395)
@@ -4,73 +4,5 @@
 #include "./Exp2Kml.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
-
-	int i,verbose=1;
-
-	/*input: */
-	char    *filexp=NULL,*filkml=NULL;
-	int     sgn;
-
-	Options* options=NULL;
-	char     *choles=NULL;
-	bool     holes=false;
-	double   cm=0.,sp=0.;
-
-	/* output: */
-	int     iret=0;
-
-	/*Boot module: */
-	MODULEBOOT();
-
-	/*checks on arguments on the matlab side: */
-	if (nlhs > NLHS) {
-		Exp2KmlUsage(); _error2_("Exp2Kml usage error");
-	}
-	if (nrhs < NRHS) {
-		Exp2KmlUsage(); _error2_("Exp2Kml usage error");
-	}
-
-	/*Input datasets: */
-	FetchData(&filexp,EXP_IN);
-	FetchData(&filkml,KML_IN);
-	FetchData(&sgn,SGN_IN);
-	FetchData(&options,NRHS,nrhs,prhs);
-
-	options->Get(&choles,"holes","no");
-	if (!strncmp(choles,"y",1) || !strncmp(choles,"on",2)) holes=true;
-
-	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
-	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
-		options->Get(&cm,"central_meridian");
-		if (verbose) _printLine_("  cm=" << cm);
-		options->Get(&sp,"standard_parallel");
-		if (verbose) _printLine_("  sp=" << sp);
-	}
-
-	/*some checks*/
-	if (sgn !=+1 && sgn !=-1) _error2_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
-	if (fabs(cm)      > 180.) _error2_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
-	if (sp < 0. || sp >  90.) _error2_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
-
-	/* Run core computations: */
-	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
-		iret=Exp2Kmlx(filexp,filkml,sgn,cm,sp,holes);
-	else
-		iret=Exp2Kmlx(filexp,filkml,sgn,holes);
-
-	/*Write data: */
-	WriteData(RET_OUT,iret);
-
-	/*Clean-up*/
-	xfree((void**)&choles);
-	delete options;
-	xfree((void**)&filkml);
-	xfree((void**)&filexp);
-
-	/*end module: */
-	MODULEEND();
-}
-
-void Exp2KmlUsage(void){
+void Exp2KmlUsage(void){/*{{{*/
 	_pprintLine_("Exp2Kml - exp to kml file conversion module:");
 	_pprintLine_("");
@@ -95,4 +27,70 @@
 	_pprintLine_("      [ret]=Exp2Kml('file.exp','file.kml',-1,'central_meridian', 0,'standard_parallel',71,'holes','yes');");
 	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Exp2Kml){
+
+	int i,verbose=1;
+
+	/*input: */
+	char    *filexp=NULL,*filkml=NULL;
+	int     sgn;
+
+	Options* options=NULL;
+	char     *choles=NULL;
+	bool     holes=false;
+	double   cm=0.,sp=0.;
+
+	/* output: */
+	int     iret=0;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	if (nlhs > NLHS) {
+		Exp2KmlUsage(); _error_("Exp2Kml usage error");
+	}
+	if (nrhs < NRHS) {
+		Exp2KmlUsage(); _error_("Exp2Kml usage error");
+	}
+
+	/*Input datasets: */
+	FetchData(&filexp,EXP_IN);
+	FetchData(&filkml,KML_IN);
+	FetchData(&sgn,SGN_IN);
+	FetchData(&options,NRHS,nrhs,prhs);
+
+	options->Get(&choles,"holes",(char*)"no");
+	if (!strncmp(choles,"y",1) || !strncmp(choles,"on",2)) holes=true;
+
+	/*  defaults are in Xy2lldef, so don't duplicate them here, and only use user values if both have been specified  */
+	if (options->GetOption("central_meridian") || options->GetOption("standard_parallel")) {
+		options->Get(&cm,"central_meridian");
+		if (verbose) _printLine_("  cm=" << cm);
+		options->Get(&sp,"standard_parallel");
+		if (verbose) _printLine_("  sp=" << sp);
+	}
+
+	/*some checks*/
+	if (sgn !=+1 && sgn !=-1) _error_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
+	if (fabs(cm)      > 180.) _error_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
+	if (sp < 0. || sp >  90.) _error_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
+
+	/* Run core computations: */
+	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
+		iret=Exp2Kmlx(filexp,filkml,sgn,cm,sp,holes);
+	else
+		iret=Exp2Kmlx(filexp,filkml,sgn,holes);
+
+	/*Write data: */
+	WriteData(RET_OUT,iret);
+
+	/*Clean-up*/
+	xDelete<char>(choles);
+	xDelete<char>(filkml);
+	xDelete<char>(filexp);
+	delete options;
+
+	/*end module: */
+	MODULEEND();
 }
-
Index: issm/trunk/src/modules/Exp2Kml/Exp2Kml.h
===================================================================
--- issm/trunk/src/modules/Exp2Kml/Exp2Kml.h	(revision 12709)
+++ issm/trunk/src/modules/Exp2Kml/Exp2Kml.h	(revision 13395)
@@ -6,6 +6,14 @@
 #define _EXP2KML_H
 
-/* local prototypes: */
-void Exp2KmlUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -18,12 +26,21 @@
 #define __FUNCT__  "Exp2Kml"
 
-
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define EXP_IN    prhs[0]
-#define KML_IN    prhs[1]
-#define SGN_IN    prhs[2]
-
+#define EXP_IN prhs[0]
+#define KML_IN prhs[1]
+#define SGN_IN prhs[2]
 /* serial output macros: */
 #define RET_OUT    (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define EXP_IN PyTuple_GetItem(args,0)
+#define KML_IN PyTuple_GetItem(args,1)
+#define SGN_IN PyTuple_GetItem(args,2)
+/* serial output macros: */
+#define RET_OUT    output,0
+#endif
 
 /* serial arg counts: */
Index: issm/trunk/src/modules/HoleFiller/HoleFiller.cpp
===================================================================
--- issm/trunk/src/modules/HoleFiller/HoleFiller.cpp	(revision 12709)
+++ issm/trunk/src/modules/HoleFiller/HoleFiller.cpp	(revision 13395)
@@ -10,10 +10,16 @@
 */
 
-
 #include "./HoleFiller.h"
 
-void mexFunction( int nlhs, mxArray* plhs[],
-				  int nrhs, const mxArray* prhs[])
-{
+void HoleFillerUsage(void){/*{{{*/
+	_printLine_("   HoleFiller usage:");
+	_printLine_("   [image_out]=HoleFiller(image_in,smooth);\n");
+	_printLine_("   where:");
+	_printLine_("      image_in in double format");
+	_printLine_("      smooth: 1 to smooth with a box filer, 0 to leave data raw");
+	_printLine_("      image_out in double format");
+	_printLine_("");
+}/*}}}*/
+WRAPPER(HoleFiller){
 
 	int i,j;
@@ -56,14 +62,2 @@
 	MODULEEND();
 }
-
-
-void HoleFillerUsage(void)
-{
-	_printLine_("   HoleFiller usage:");
-	_printLine_("   [image_out]=HoleFiller(image_in,smooth);\n");
-	_printLine_("   where:");
-	_printLine_("      image_in in double format");
-	_printLine_("      smooth: 1 to smooth with a box filer, 0 to leave data raw");
-	_printLine_("      image_out in double format");
-	_printLine_("");
-}
Index: issm/trunk/src/modules/HoleFiller/HoleFiller.h
===================================================================
--- issm/trunk/src/modules/HoleFiller/HoleFiller.h	(revision 12709)
+++ issm/trunk/src/modules/HoleFiller/HoleFiller.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	HoleFiller.h
 */
 
-
 #ifndef _HOLEFILLER_H
 #define _HOLEFILLER_H
 
-/* local prototypes: */
-void HoleFillerUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -20,11 +26,19 @@
 #define __FUNCT__  "HoleFiller"
 
-
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
 #define IMAGEIN prhs[0]
-#define SMOOTH prhs[1]
+#define SMOOTH  prhs[1]
+/* serial output macros: */
+#define IMAGEOUT (mxArray**)&plhs[0]
+#endif
 
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define IMAGEIN PyTuple_GetItem(args,0)
+#define SMOOTH  PyTuple_GetItem(args,1)
 /* serial output macros: */
-#define IMAGEOUT &plhs[0]
+#define IMAGEOUT output,0
+#endif
 
 /* serial arg counts: */
